/************************************************
* BP - example of based pointer usage			*
************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <graph.h>
#include <conio.h>
#include <ctype.h>

#define TRUE (1==1)
#define ISIN(l,u,v) ((v>=l)&&(v<=u))

short screenmode;
_segment screenbase;
char (_based(screenbase) *Screen)[24][80][2];

void atsay(int r, int c, int atr, char *s)
	{
	if (!ISIN(0,23,r) || !ISIN(0,79,c))
		return;
	while ((c<=79) && (*s))
		{
		(*Screen)[r][c][0]=*s;
		(*Screen)[r][c++][1]=(char)atr;
		s++;
		}
	}

void main(void)
	{
	int c,i,j;
	char workbuf[10];

	/* Find video display type */
	puts("Do you have an MDA or Herc card?");
	for (c=0; c==0; )
		{
		c=getch();
		c=toupper(c);
		if (c=='Y')
			{
			screenbase = (_segment)0xb000;
			screenmode = _TEXTMONO;
			}
		else if (c=='N')
			{
			screenbase = (_segment)0xb800;
			screenmode = _TEXTC80;
			}
		else
			{
			puts("\bPlease answer Y or N");
			c=0;	/* keep waiting for answer	*/
			}
		}

	/* Set the appropriate video mode */
	if (!_setvideomode(screenmode))
		{
		puts("Error - could not set the appropri"
			 "ate screen mode");
		exit(1);
		}

	/* Print character/attribute combinations */
	for (c=i=0; i<16; ++i)
		for (j=0; j<16; ++j,++c)
			{
			sprintf(workbuf,"%03d",c);
			atsay(i+4,j*3,c,workbuf);
			}
	}
